﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;

namespace ComboEditorRollback
{
	public partial class RollbackedComboEditor : UltraComboEditor
	{
		public event EventHandler<CancelNewEventArgs> ValueChanging;
		protected object oldValue;
		private bool skipValueChanging;

		public RollbackedComboEditor()
		{
			InitializeComponent();
			oldValue = null;
		}

		protected override void OnPaint(PaintEventArgs pe)
		{
			base.OnPaint(pe);
		}

		protected override void OnValueChanged(EventArgs args)
		{
			if (!skipValueChanging)
			{
				CancelNewEventArgs e = new CancelNewEventArgs();
				OnValueChanging(e);

				if (e.Cancelled)
				{
					skipValueChanging = true;
					
					if (oldValue == null)
						this.SelectedItem = null;
					else
						Value = oldValue;
					
					skipValueChanging = false;
				}

			}

			oldValue = Value;

			base.OnValueChanged(args);
		}

		protected virtual void OnValueChanging(CancelNewEventArgs args)
		{
			if (ValueChanging != null)
			{
				ValueChanging(this, args);
			}
		}
	}
}
